diff --git a/src/main/java/net/minecraft/client/gui/GuiEditFlag.java b/src/main/java/net/minecraft/client/gui/GuiEditFlag.java
index 2297177f7..1cd9941da 100644
--- a/src/main/java/net/minecraft/client/gui/GuiEditFlag.java
+++ b/src/main/java/net/minecraft/client/gui/GuiEditFlag.java
@@ -1,26 +1,26 @@
 package net.minecraft.client.gui;
 
+import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.entity.player.Player;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.gui.drawing.DrawableEditor;
 import net.minecraft.client.gui.drawing.IDrawableSurface;
 import net.minecraft.client.util.helper.Colors;
-import net.minecraft.core.block.entity.TileEntityFlag;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.net.packet.Packet250CustomPayload;
-import net.minecraft.core.player.inventory.ContainerFlag;
+import net.minecraft.core.net.packet.CustomPayloadPacket;
+import net.minecraft.core.player.inventory.menu.FlagMenu;
 import net.minecraft.core.util.helper.MathHelper;
 
 public class GuiEditFlag
     extends GuiContainer
     implements IDrawableSurface<Byte>
 {
-    private final TileEntityFlag tileEntity;
+    private final FlagBlockEntity tileEntity;
     private final int CANVAS_SCALE = 4;
     private final int CANVAS_WIDTH = 24;
     private final int CANVAS_HEIGHT = 16;
@@ -44,9 +44,9 @@ public class GuiEditFlag
     GuiSurface flagSurface;
     GuiSurface drawOverlaySurface;
     
-    public GuiEditFlag(EntityPlayer player, TileEntityFlag flagTileEntity)
+    public GuiEditFlag(Player player, FlagBlockEntity flagTileEntity)
     {
-        super(new ContainerFlag(player.inventory, flagTileEntity));
+        super(new FlagMenu(player.inventory, flagTileEntity));
         this.tileEntity = flagTileEntity;
         xSize = 176;
         ySize = 195;
@@ -71,7 +71,7 @@ public class GuiEditFlag
 
         for (int i = 0; i < 7; i++)
         {
-            toolBtns[i] = new GuiTexturedButton(i, "/assets/minecraft/textures/gui/flag_editor.png", (width - xSize) / 2 + 12 + 22 * i, (height - ySize) / 2 + 76, 20 * i, 195, 20, 20);
+            toolBtns[i] = new GuiTexturedButton(i, "/assets/minecraft/textures/gui/container/flag_editor.png", (width - xSize) / 2 + 12 + 22 * i, (height - ySize) / 2 + 76, 20 * i, 195, 20, 20);
             if (i == activeTool) toolBtns[i].enabled = false;
             controlList.add(toolBtns[i]);
         }
@@ -97,8 +97,8 @@ public class GuiEditFlag
         int[] colors = new int[5];
         for (int i = 1; i < 4; i++)
         {
-            ItemStack stack = tileEntity.getStackInSlot(35 + i);
-            if (stack != null && stack.getItem() == Item.dye)
+            ItemStack stack = tileEntity.getItem(35 + i);
+            if (stack != null && stack.getItem() == Items.DYE)
             {
                 colors[i] = Colors.allFlagColors[TextFormatting.get(15 - stack.getMetadata()).id].getARGB();
             }
@@ -120,7 +120,7 @@ public class GuiEditFlag
         super.mouseClicked(mouseX, mouseY, mouseButton);
         
         // Do not draw with no color selected
-        if(tileEntity.getStackInSlot(36 + selectedColor) == null) {
+        if(tileEntity.getItem(36 + selectedColor) == null) {
         	return;
         }
         
@@ -317,9 +317,8 @@ public class GuiEditFlag
     @Override
     protected void drawGuiContainerBackgroundLayer(float f) 
     {
-        int i = mc.renderEngine.getTexture("/assets/minecraft/textures/gui/flag_editor.png");
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.bindTexture(i);
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/flag_editor.png").bind();
         int j = (width - xSize) / 2;
         int k = (height - ySize) / 2;
         drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
@@ -394,7 +393,7 @@ public class GuiEditFlag
         {
     		// Flag packet needs to be sent before the close screen packet is sent!
     		if(mc.theWorld.isClientSide) {
-    			mc.getSendQueue().addToSendQueue(new Packet250CustomPayload("BTA|Flag", tileEntity.flagColors));
+    			mc.getSendQueue().addToSendQueue(new CustomPayloadPacket("BTA|Flag", tileEntity.flagColors));
     		}
             mc.thePlayer.closeScreen();
         }
diff --git a/src/main/java/net/minecraft/client/gui/GuiEditLabel.java b/src/main/java/net/minecraft/client/gui/GuiEditLabel.java
index 684d93e2d..b839adbf9 100644
--- a/src/main/java/net/minecraft/client/gui/GuiEditLabel.java
+++ b/src/main/java/net/minecraft/client/gui/GuiEditLabel.java
@@ -3,14 +3,14 @@ package net.minecraft.client.gui;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.net.packet.Packet137SetItemName;
+import net.minecraft.core.net.packet.SetItemNamePacket;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            GuiScreen, GuiButton, World, Packet130UpdateSign,
-//            TileEntitySign, NetClientHandler, Block, TileEntityRenderer,
+//            GuiScreen, GuiButton, World, SignUpdatePacket,
+//            SignBlockEntity, ClientPacketHandler, Block, BlockEntityRenderer,
 //            ChatAllowedCharacters
 
 public class GuiEditLabel extends GuiScreen
@@ -58,7 +58,7 @@ public class GuiEditLabel extends GuiScreen
 
             if (mc.theWorld.isClientSide)
             {
-                mc.getSendQueue().addToSendQueue(new Packet137SetItemName(slot, text));
+                mc.getSendQueue().addToSendQueue(new SetItemNamePacket(slot, text));
             }
         }
     }
@@ -67,9 +67,8 @@ public class GuiEditLabel extends GuiScreen
     public void drawScreen(final int mouseX, final int mouseY, final float f)
     {
         drawDefaultBackground();
-        final int bgTex = mc.renderEngine.getTexture("/assets/minecraft/textures/gui/scroll.png");
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.bindTexture(bgTex);
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/scroll.png").bind();
         final int widthBG = width / 2 - 56;
         final int heightBG = 89;
         drawTexturedModalRect(widthBG, heightBG, 0, 0, 113, 34);
diff --git a/src/main/java/net/minecraft/client/gui/GuiEditSign.java b/src/main/java/net/minecraft/client/gui/GuiEditSign.java
index 206a4003e..881c2f6f4 100644
--- a/src/main/java/net/minecraft/client/gui/GuiEditSign.java
+++ b/src/main/java/net/minecraft/client/gui/GuiEditSign.java
@@ -1,19 +1,20 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.SignBlockEntity;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
-import net.minecraft.core.net.packet.Packet130UpdateSign;
-import net.minecraft.client.render.TileEntityRenderDispatcher;
+import net.minecraft.core.net.packet.SignUpdatePacket;
+import net.minecraft.client.render.BlockEntityRenderDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.lang.I18n;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
 public class GuiEditSign extends GuiScreen
 {
-    public GuiEditSign(TileEntitySign tileentitysign)
+    public GuiEditSign(SignBlockEntity tileentitysign)
     {
         screenTitle = I18n.getInstance().translateKey("gui.edit_sign.label.title");
         editLine = 0;
@@ -27,7 +28,7 @@ public class GuiEditSign extends GuiScreen
         Keyboard.enableRepeatEvents(true);
 
         Block block = entitySign.getBlockType();
-        if(block == Block.signPostPlanksOak) 
+        if(block == Blocks.SIGN_POST_PLANKS_OAK)
         {
             yOffset = 36;
         }
@@ -46,7 +47,7 @@ public class GuiEditSign extends GuiScreen
         // but thaboar was getting a crash from the world being null
         if(mc.theWorld != null && mc.theWorld.isClientSide)
         {
-            mc.getSendQueue().addToSendQueue(new Packet130UpdateSign(entitySign.x, entitySign.y, entitySign.z, entitySign.signText, entitySign.getPicture().getId(), entitySign.getColor().id));
+            mc.getSendQueue().addToSendQueue(new SignUpdatePacket(entitySign.x, entitySign.y, entitySign.z, entitySign.signText, entitySign.getPicture().getId(), entitySign.getColor().id));
         }
     }
 
@@ -65,7 +66,7 @@ public class GuiEditSign extends GuiScreen
         }
         if(button.id == 0)
         {
-            entitySign.onInventoryChanged();
+            entitySign.setChanged();
             mc.displayGuiScreen(null);
         }
         if (button.id == 1)
@@ -74,7 +75,7 @@ public class GuiEditSign extends GuiScreen
             int lastId = id - 1;
             if (lastId < 0) lastId = EnumSignPicture.values().length - 1;
             entitySign.setPicture(EnumSignPicture.values()[lastId]);
-            entitySign.onInventoryChanged();
+            entitySign.setChanged();
         }
         if (button.id == 2)
         {
@@ -82,7 +83,7 @@ public class GuiEditSign extends GuiScreen
             int nextId = id + 1;
             if (nextId >= EnumSignPicture.values().length) nextId = 0;
             entitySign.setPicture(EnumSignPicture.values()[nextId]);
-            entitySign.onInventoryChanged();
+            entitySign.setChanged();
         }
     }
 
@@ -91,7 +92,7 @@ public class GuiEditSign extends GuiScreen
     {
     	if(i == Keyboard.KEY_ESCAPE)
     	{
-            entitySign.onInventoryChanged();
+            entitySign.setChanged();
     		mc.displayGuiScreen(null);
     	}
         if(i == 200)
@@ -123,7 +124,7 @@ public class GuiEditSign extends GuiScreen
         GL11.glScalef(-scale, -scale, -scale);
         GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
         Block block = entitySign.getBlockType();
-        if(block == Block.signPostPlanksOak)
+        if(block == Blocks.SIGN_POST_PLANKS_OAK)
         {
             float signAngle = (float)(entitySign.getMovedData() * 360) / 16F;
             GL11.glRotatef(signAngle, 0.0F, 1.0F, 0.0F);
@@ -151,7 +152,7 @@ public class GuiEditSign extends GuiScreen
         {
             entitySign.lineBeingEdited = editLine;
         }
-        TileEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, entitySign, -0.5D, -0.75D, -0.5D, 0.0F);
+        BlockEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, entitySign, -0.5D, -0.75D, -0.5D, 0.0F);
         entitySign.lineBeingEdited = -1;
         GL11.glPopMatrix();
         
@@ -161,7 +162,7 @@ public class GuiEditSign extends GuiScreen
     }
 
     protected String screenTitle;
-    private TileEntitySign entitySign;
+    private SignBlockEntity entitySign;
     private int updateCounter;
     private int editLine;
     private int yOffset = 0;
diff --git a/src/main/java/net/minecraft/client/gui/GuiFurnace.java b/src/main/java/net/minecraft/client/gui/GuiFurnace.java
index 9af439b44..325ea10d7 100644
--- a/src/main/java/net/minecraft/client/gui/GuiFurnace.java
+++ b/src/main/java/net/minecraft/client/gui/GuiFurnace.java
@@ -1,19 +1,19 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.core.block.entity.BlastFurnaceBlockEntity;
+import net.minecraft.core.block.entity.FurnaceBlockEntity;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.player.inventory.ContainerFurnace;
-import net.minecraft.core.player.inventory.InventoryPlayer;
-import net.minecraft.core.block.entity.TileEntityBlastFurnace;
-import net.minecraft.core.block.entity.TileEntityFurnace;
+import net.minecraft.core.player.inventory.menu.FurnaceMenu;
+import net.minecraft.core.player.inventory.container.Inventory;
 import org.lwjgl.opengl.GL11;
 
 public class GuiFurnace extends GuiContainer
 {
 
-    public GuiFurnace(InventoryPlayer inventoryplayer, TileEntityFurnace tileentityfurnace)
+    public GuiFurnace(Inventory inventoryplayer, FurnaceBlockEntity tileentityfurnace)
     {
-        super(new ContainerFurnace(inventoryplayer, tileentityfurnace));
+        super(new FurnaceMenu(inventoryplayer, tileentityfurnace));
         furnaceInventory = tileentityfurnace;
     }
 
@@ -21,7 +21,7 @@ public class GuiFurnace extends GuiContainer
 	protected void drawGuiContainerForegroundLayer()
     {
         I18n i18n = I18n.getInstance();
-        if(furnaceInventory instanceof TileEntityBlastFurnace) {
+        if(furnaceInventory instanceof BlastFurnaceBlockEntity) {
             fontRenderer.drawString(i18n.translateKey("gui.furnace.blast.label.blast_furnace"), 60, 6, 0x404040);
         } else {
             fontRenderer.drawString(i18n.translateKey("gui.furnace.label.furnace"), 60, 6, 0x404040);
@@ -32,20 +32,18 @@ public class GuiFurnace extends GuiContainer
     @Override
 	protected void drawGuiContainerBackgroundLayer(float f)
     {
-        int guiTexture;
-        if(furnaceInventory instanceof TileEntityBlastFurnace) {
-            guiTexture = mc.renderEngine.getTexture("/assets/minecraft/textures/gui/blastfurnace.png");
+        if(furnaceInventory instanceof BlastFurnaceBlockEntity) {
+            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/blastfurnace.png").bind();
         } else {
-            guiTexture = mc.renderEngine.getTexture("/assets/minecraft/textures/gui/furnace.png");
+            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/furnace.png").bind();
         }
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.bindTexture(guiTexture);
         int x = (width - xSize) / 2;
         int y = (height - ySize) / 2;
         drawTexturedModalRect(x, y, 0, 0, xSize, ySize);
         if(furnaceInventory.isBurning())
         {
-            if (furnaceInventory instanceof TileEntityBlastFurnace) {
+            if (furnaceInventory instanceof BlastFurnaceBlockEntity) {
                 int fireHeight = furnaceInventory.getBurnTimeRemainingScaled(14);
                 drawTexturedModalRect(x + 56, y + 35 + 14 - fireHeight, 176, 14 - fireHeight, 14, fireHeight + 2);
                 int arrowWidth = furnaceInventory.getCookProgressScaled(24);
@@ -64,5 +62,5 @@ public class GuiFurnace extends GuiContainer
         controller.craftingGuiHandler.handleFurnace(this);
     }
 
-    private final TileEntityFurnace furnaceInventory;
+    private final FurnaceBlockEntity furnaceInventory;
 }
diff --git a/src/main/java/net/minecraft/client/gui/GuiGameOver.java b/src/main/java/net/minecraft/client/gui/GuiGameOver.java
index 8593ee79c..ee948cfb7 100644
--- a/src/main/java/net/minecraft/client/gui/GuiGameOver.java
+++ b/src/main/java/net/minecraft/client/gui/GuiGameOver.java
@@ -1,15 +1,15 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.entity.player.EntityClientPlayerMP;
+import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.net.packet.Packet0KeepAlive;
+import net.minecraft.core.net.packet.KeepAlivePacket;
 import net.minecraft.core.player.gamemode.Gamemode;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.core.net.command.TextFormatting;
 
 // Referenced classes of package net.minecraft.src:
-//            GuiScreen, GuiButton, EntityPlayerSP, GuiMainMenu
+//            GuiScreen, GuiButton, LocalPlayer, GuiMainMenu
 
 public class GuiGameOver extends GuiScreen
 {
@@ -21,9 +21,9 @@ public class GuiGameOver extends GuiScreen
     @Override
     public void tick(){
         tickCount++;
-        if (mc.isMultiplayerWorld() && mc.thePlayer instanceof EntityClientPlayerMP && tickCount % 10 == 0){
-            EntityClientPlayerMP clientPlayerMP = (EntityClientPlayerMP) mc.thePlayer;
-            clientPlayerMP.sendQueue.addToSendQueue(new Packet0KeepAlive());
+        if (mc.isMultiplayerWorld() && mc.thePlayer instanceof MultiplayerLocalPlayer && tickCount % 10 == 0){
+            MultiplayerLocalPlayer clientPlayerMP = (MultiplayerLocalPlayer) mc.thePlayer;
+            clientPlayerMP.sendQueue.addToSendQueue(new KeepAlivePacket());
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiHudDesigner.java b/src/main/java/net/minecraft/client/gui/GuiHudDesigner.java
index 586e4e05e..9c6dec263 100644
--- a/src/main/java/net/minecraft/client/gui/GuiHudDesigner.java
+++ b/src/main/java/net/minecraft/client/gui/GuiHudDesigner.java
@@ -33,7 +33,8 @@ public class GuiHudDesigner
         mc.gameSettings.screenPadding.set(0.0f);
 
         add(new GuiButton(0, width / 2 - 100, height - BOTTOM_SPACE + (BOTTOM_SPACE - 20) / 2, 178, 20, I18n.getInstance().translateKey("gui.hud_designer.button.done")));
-        add(resetButton = new GuiTexturedButton(1, "/assets/minecraft/textures/gui/gui.png", width / 2 + 80, height - BOTTOM_SPACE + (BOTTOM_SPACE - 20) / 2, 20 * 4, 86, 20, 20));
+        add(resetButton = new GuiButton(1, width / 2 + 80, height - BOTTOM_SPACE + (BOTTOM_SPACE - 20) / 2, 20, 20, "")
+            .setTextures("minecraft:gui/misc/button_reset", "minecraft:gui/misc/button_reset_highlighted", "minecraft:gui/misc/button_reset"));
     }
 
     @Override
@@ -267,7 +268,7 @@ public class GuiHudDesigner
         GL11.glDisable(GL11.GL_LIGHTING);
         GL11.glDisable(GL11.GL_FOG);
         Tessellator tessellator = Tessellator.instance;
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/designer_bg.png"));
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/designer_bg.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         float scale = 32F;
         tessellator.startDrawingQuads();
